//
//  ac.h
//  VecTripper
//
//  Created by tmkk on 09/07/31.
//  Copyright 2009 tmkk. All rights reserved.
//

#define NODEPTR(n, ac) (ac->trie+n)

typedef struct
{
	unsigned int next[65];
	char idx[12];
	int distance;
	unsigned int valid1, valid2;
} AC_node;

typedef struct
{
	AC_node *trie;
	int minlen;
	int nodenum;
} AC_t;

AC_t *AC_new(void);
void AC_add_pattern(char *pattern, int length, int idx, AC_t *ac);
void AC_init_tree(AC_t *ac);
void AC_free(AC_t *ac);
